#include <stdio.h>
#include <stdlib.h>
#ifdef _WIN32_
#include <io.h>
#endif
#include <fcntl.h>

#include "wtb.h"

#define BUFFER_SIZE 4096

static unsigned char*buffer = NULL;  // ХåեǤ
static int handle;  // եΥϥɥ
static int buffer_readed;  // եɤ߹ߺѤߥХȿ
static int buffer_size;  // ХåեΥ
static int buffer_pt;  // Хåեΰ
static int opened = 0;  // եϳƤޤ (0:Ƥޤ)
static unsigned long bit_buffer;  // Ĥӥå
static int rest_bit;  // bit_bufferλĤӥåȿ 3Ȥ11100000111ͭ
static unsigned long be_check = WTB_BIGENDIAN;

// n bitʬΥǡ
// 16bitʤΤդ
static int bit_get(int n)
{
	unsigned int ret;
	if (opened==0) return -1;
	if (n>16) return -1;  // ܤ
	for(;;) {
		// bit­
		if (rest_bit >= n) {
			ret = (bit_buffer >> (32-n));
			rest_bit -= n;
			bit_buffer <<= n;
			return (int)ret;
		}
		// 佼
		if (buffer_pt==buffer_readed) {
			buffer_readed = read(handle, buffer, buffer_size);
			if (buffer_readed==0) {
				return -1;  // ʾܤǤ
			}
			buffer_pt = 0;
		}
		bit_buffer |= (buffer[buffer_pt++] << (32 - rest_bit - 8));
		rest_bit += 8;
	}
}


// n bitʬΥǡ񤭹
// 16bitʤΤդ
static int bit_write(FILE* fp, int n, unsigned long w)
{
	if (n>16) return -1;  // ܤ
	bit_buffer |= (w << (32 - rest_bit - n));
	rest_bit += n;
	while (rest_bit >= 8) {
		putc((bit_buffer >> (32-8)), fp);  // 񤭹
		rest_bit -= 8;
		bit_buffer <<= 8;
	}
	return 0;
}


// ĤäƤӥåȥǡ񤭹
static int bit_flush(FILE* fp)
{
	while (rest_bit >= 8) {
		putc((bit_buffer >> (32-8)), fp);  // 񤭹
		rest_bit -= 8;
		bit_buffer <<= (32-8);
	}
	if (rest_bit) {
		putc((bit_buffer >> (32-8)), fp);
	}
	return 0;
}


// եΥץ
static int open_file(char* fname)
{
	if (buffer==NULL) {
		buffer = (unsigned char*)malloc(BUFFER_SIZE);
		if (buffer==NULL) return -1;  // ХåեդԤʤΤǽ
		buffer_size = BUFFER_SIZE;
	}
	if (opened) {
		close(handle);
		opened = 0;
	}
#ifdef _WIN32_
	handle = open(fname, O_RDONLY | O_BINARY);
#else
	handle = open(fname, O_RDONLY);
#endif
	if (handle==-1) return -1;  // ץԤ
	opened = 1;
	buffer_pt = 0;
	buffer_readed = 0;
	bit_buffer = 0;
	rest_bit = 0;
	return 0;
}


// äˤ뤳Ȥ̵Τ
static int close_file()
{
	if (opened==0) return -1;
	close(handle);
	return 0;
}



// ͤɤ߹
static int num_read()
{
	int ret;
	ret = bit_get(1);
	if (ret==-1) return -1;
	if (ret==0) return 1;
	ret = bit_get(1);
	if (ret==-1) return -1;
	if (ret==0) {
		ret = bit_get(4);
		if (ret==-1) return -1;
		return ret + 2;
	}
	ret = bit_get(1);
	if (ret==-1) return -1;
	if (ret==0) {
		ret = bit_get(8);
		if (ret==-1) return -1;
		return ret + 18;
	}
	ret = bit_get(1);
	if (ret==-1) return -1;
	if (ret!=0) {
		return -1;
	}
	ret = bit_get(16);
	return ret + 274;
}


// ͤν񤭹
static void num_write(FILE*fp, int num)
{
	if (num<=0) return;  // ɤ褦ʤǤ
	if (num==1) {
		bit_write(fp, 1, 0);
		return;
	}
	if (num<18) {
		bit_write(fp, 2, 2);
		bit_write(fp, 4, num - 2);
		return;
	}
	if (num<274) {
		bit_write(fp, 3, 6);
		bit_write(fp, 8, num - 18);
		return;
	}
	bit_write(fp, 4, 14);
	bit_write(fp, 16, num - 274);
}



// WTB
// bufФƥ᡼ɤ롣ΥХåե=width⤵=heightrawBytes=raw
// ᡼Υ(ox,oy)Ȥ
// rgbNULLǤʤХѥåȤɤ()
int WTBLoad(char* fname, unsigned char* buf, int width, int height, int raw, int ox, int oy, char* rgb)
{
	struct WTBHeader head;
	int img_width, img_height, x, y, ret;
	int rep, com, i, j;
	int err, val;
	unsigned char* line[3];  // ɥХåե
	int lpos = 0;
	char rgb_buf[256*3];  // ѥåɤ߼ΤѤΥХåե

	if (open_file(fname)) return -1;  // 
	ret = read(handle, &head, sizeof(head));
	if (ret!=sizeof(head)) {
		close_file();  // ե륵­Ƥʤ
		return -1;
	}
	if (memcmp(&head, (void*)&be_check, 4) == 0){
		// Big Endian
		union {
			unsigned char c[4];
			unsigned long l;
		} cv;
		unsigned char t;
		
		cv.l = head.ID;
		t = cv.c[0];
		cv.c[0] = cv.c[3];
		cv.c[3] = t;
		t = cv.c[1];
		cv.c[1] = cv.c[2];
		cv.c[2] = t;
		head.ID = cv.l;
		
		cv.l = head.width;
		t = cv.c[0];
		cv.c[0] = cv.c[3];
		cv.c[3] = t;
		t = cv.c[1];
		cv.c[1] = cv.c[2];
		cv.c[2] = t;
		head.width = cv.l;
		
		cv.l = head.height;
		t = cv.c[0];
		cv.c[0] = cv.c[3];
		cv.c[3] = t;
		t = cv.c[1];
		cv.c[1] = cv.c[2];
		cv.c[2] = t;
		head.height = cv.l;
		
		cv.l = head.deapth;
		t = cv.c[0];
		cv.c[0] = cv.c[3];
		cv.c[3] = t;
		t = cv.c[1];
		cv.c[1] = cv.c[2];
		cv.c[2] = t;
		head.deapth = cv.l;
		
		cv.l = head.opt[0];
		t = cv.c[0];
		cv.c[0] = cv.c[3];
		cv.c[3] = t;
		t = cv.c[1];
		cv.c[1] = cv.c[2];
		cv.c[2] = t;
		head.opt[0] = cv.l;
	}
	if (head.ID!=WTBID || head.deapth!=8) {  // IDäꡢdeapth8ʤܤǤ
		close_file();
		return -1;
	}
	if (head.opt[0]!=0) {  // ѥåȤ
		if (rgb!=NULL) {
			ret = read(handle, rgb, 256*3);
		} else {
			ret = read(handle, rgb_buf, 256*3);  // ɤ߼Τ
		}
		if (ret!=256*3) {
			close_file();
			return -1;
		}
	}
	img_width  = head.width;
	img_height = head.height;
	// lineХåեγդ
	for(i=0; i<3; i++) {
		line[i] = malloc(img_width);
		if (line[i]==NULL) {  // 
			for (j=0; j<i; j++) {
				free(line[j]);
				close_file();
				return -1;
			}
		}
	}
	// ɤा
	lpos = 0;
	for(y=0; y<img_height; y++) {
		if (y+oy >= height) break;  // ʾϥɤɬפ̵
		x = 0;
		err = 0;
		while(x < img_width) {
			rep = num_read();
			if (rep==-1) {
				err = 1;  // 顼
				break;
			}
			com = bit_get(3);
			for(i=0; i<rep; i++) {
				switch(com) {
				case 0:  // load
					val = bit_get(8);
					if (val==-1) {
						err = -1;
						break;
					}
					line[lpos][x] = val;
					break;
				case 1:  // 0,-1
					if (lpos==0) {
						err = 1;  // 顼
					} else {
						line[lpos][x] = line[lpos-1][x];
					}
					break;
				case 2:  // 0, -2
					if (lpos<2) {
						err = 1;  // 顼
					} else {
						line[lpos][x] = line[lpos-2][x];
					}
					break;
				case 3:  // -1,0
					if (x==0) {
						err = 1;  // 顼
					} else {
						line[lpos][x] = line[lpos][x-1];
					}
					break;
				case 4:  // -1,-1
					if (x==0 || lpos==0) {
						err = 1;  // 顼
					} else {
						line[lpos][x] = line[lpos-1][x-1];
					}
					break;
				case 5:  // -2,0
					if (x<2) {
						err = 1;  // 顼
					} else {
						line[lpos][x] = line[lpos][x-2];
					}
					break;
				case 6:  // -2,-2
					if (x<2 || lpos<2) {
						err = 1;  // 顼
					} else {
						line[lpos][x] = line[lpos-2][x-2];
					}
					break;
				case 7: // ̤Ǥ
					err = 1;
					break;
				}
				if (err) break;
				if (++x > img_width) {
					err = 1;
					break;
				}
			}
			if (err) break;
		}  // end of one-line load
		if (err) break;
		// ԡƤ
		for(i=0; i<img_width; i++) {
			if (ox+i>=width) break;  // ʾϥԡɬ̵
			buf[y*raw + ox+i] = line[lpos][i];
		}
		lpos++;
		if (lpos >= 3) {
			// Хåեޤ路Ƥ
			unsigned char* tmp;
			
			lpos = 2;
			tmp = line[0];
			line[0] = line[1];
			line[1] = line[2];
			line[2] = tmp;
		}
	}
	close_file();
	for(i=0; i<3; i++) free(line[i]);
	if (err) return -1;
	return 0;
}


// WTBС
int WTBSave(char* fname, unsigned char* buf, int width, int height, int raw, char* rgb)
{
	struct WTBHeader head;
	FILE* fp;
	int x, y, rep, i;
	unsigned int now;
	unsigned char*flags;

	// إåιۡ񤭤
	head.ID = WTBID;
	head.deapth = 8;
	head.width = width;
	head.height = height;
	if (rgb!=NULL) {
		head.opt[0] = 1;
	} else {
		head.opt[0] = 0;
	}
	fp = fopen(fname, "wb");
	if (fp==NULL) {
		return -1;  // 
	}
	fwrite(&head, sizeof(head), 1, fp);
	if (rgb!=NULL) {
		fwrite(rgb, 256*3, 1, fp);
	}
	// 櫓ǡΤν񤭹
	bit_buffer = 0;
	rest_bit = 0;
	flags = (unsigned char*)malloc(width);
	if (flags==NULL) {
		fclose(fp);  // 
		return -1;
	}
	for(y=0; y<height; y++) {
		// ե饰ޤä
		for(x=0; x<width; x++) {
			flags[x] = 0;
			if (y>=1 && buf[y*raw + x]==buf[(y-1)*raw + x]) flags[x] |= (1<<0);
			if (y>=2 && buf[y*raw + x]==buf[(y-2)*raw + x]) flags[x] |= (1<<1);
			if (x>=1 && buf[y*raw + x]==buf[y*raw + (x-1)]) flags[x] |= (1<<2);
			if (x>=1 && y>=1 && buf[y*raw + x]==buf[(y-1)*raw + (x-1)]) flags[x] |= (1<<3);
			if (x>=2 && buf[y*raw + x]==buf[y*raw + (x-2)]) flags[x] |= (1<<4);
			if (x>=2 && y>=2 && buf[y*raw + x]==buf[(y-2)*raw + (x-2)]) flags[x] |= (1<<5);
		}
		// 񤭹
		for(x=0; x<width; ) {
			if (flags[x]==0) {
				// ͽ񤭹
				rep = 0;
				while(x+rep<width && flags[x+rep]==0) {
					rep++;
				}
				num_write(fp, rep);
				bit_write(fp, 3, 0);
				for(i=0; i<rep; i++) {
					bit_write(fp, 8, buf[y*raw + x + i]);
				}
				x += rep;
			} else {
				// Ĺե饰󥹤񤭹
				int com;

				now = flags[x];
				rep = 1;
				while (x+rep<width && ((now&flags[x+rep])!=0)) {
					now &= flags[x+rep];
					rep++;
				}
				num_write(fp, rep);
				if (now & (1<<0)) com = 1;
				else if (now & (1<<1)) com = 2;
				else if (now & (1<<2)) com = 3;
				else if (now & (1<<3)) com = 4;
				else if (now & (1<<4)) com = 5;
				else if (now & (1<<5)) com = 6;
				else {
					// 
					free(flags);
					fclose(fp);
					return -1;
				}
				bit_write(fp, 3, com);
				x += rep;
			}
		}
	}
	bit_flush(fp);
	free(flags);
	fclose(fp);  // 
	return 0;
}


// WTB
// 줾졢NULLä֤ͤʤ¸ߤʤȤIDѤȤϥ顼ȤȤ-1
int WTBInfo(char* fname, int *width, int *height, int* deapth, char* rgb)
{
	struct WTBHeader head;
	FILE* fp;
	fp = fopen(fname, "rb");
	if (fp==NULL) {
		return -1;  // 
	}
	fread(&head, sizeof(head), 1, fp);
	if (memcmp(&head, (void*)&be_check, 4) == 0){
		// Big Endian
		union {
			unsigned char c[4];
			unsigned long l;
		} cv;
		unsigned char t;
		
		cv.l = head.ID;
		t = cv.c[0];
		cv.c[0] = cv.c[3];
		cv.c[3] = t;
		t = cv.c[1];
		cv.c[1] = cv.c[2];
		cv.c[2] = t;
		head.ID = cv.l;
		
		cv.l = head.width;
		t = cv.c[0];
		cv.c[0] = cv.c[3];
		cv.c[3] = t;
		t = cv.c[1];
		cv.c[1] = cv.c[2];
		cv.c[2] = t;
		head.width = cv.l;
		
		cv.l = head.height;
		t = cv.c[0];
		cv.c[0] = cv.c[3];
		cv.c[3] = t;
		t = cv.c[1];
		cv.c[1] = cv.c[2];
		cv.c[2] = t;
		head.height = cv.l;
		
		cv.l = head.deapth;
		t = cv.c[0];
		cv.c[0] = cv.c[3];
		cv.c[3] = t;
		t = cv.c[1];
		cv.c[1] = cv.c[2];
		cv.c[2] = t;
		head.deapth = cv.l;
		
		cv.l = head.opt[0];
		t = cv.c[0];
		cv.c[0] = cv.c[3];
		cv.c[3] = t;
		t = cv.c[1];
		cv.c[1] = cv.c[2];
		cv.c[2] = t;
		head.opt[0] = cv.l;
	}
	if (head.ID!=WTBID) {
		fclose(fp);
		return -1;
	}
	if (width!=NULL) {
		*width = head.width;
	}
	if (height!=NULL) {
		*height = head.height;
	}
	if (deapth!=NULL) {
		*deapth = head.deapth;
	}
	if (rgb!=NULL) {
		if (head.opt[0]) {
			fread(rgb, 256*3, 1, fp);
		}
	}
	fclose(fp);
	return 0;
}


