#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "x_player.h"
#include "x_util.h"
#include "text.h"
#include "dhm.h"

x_player::x_player(int _id, int _tx, int _ty, int _gx, int _gy, char* _name)
		: player()
{
	id = _id;
	tx = _tx;
	ty = _ty;
	gx = _gx;
	gy = _gy;
	name = new char[strlen(_name) + 1];
	strcpy(name, _name);
	gc = XCreateGC(dis, rootwin, 0, 0);
}


x_player::~x_player()
{
	delete name;
	XFreeGC(dis, gc);
}


/*
========================================================================
ǽ: ɽ
: win = Window
: ʤ
­: face_pix[x][0]̾δɽ
========================================================================
*/
void
x_player::disp_face(Window win)
{
	XCopyArea(dis,
			  face_pix[id][0],
			  win,
			  gc,
			  0, 0,
			  FACE_X, FACE_Y,
			  gx, gy);
}


/*
========================================================================
ǽ: ˥ƥɽ
: win = Window
: ʤ
­: face_pix[x][1]δɽ
========================================================================
*/
void
x_player::disp_init(Window win)
{
	XCopyArea(dis,
			  face_pix[id][1],
			  win,
			  gc,
			  0, 0,
			  FACE_X, FACE_Y,
			  gx, gy);
}


/*
========================================================================
ǽ: ξõ
: win = Window
: ʤ
­: disp_face / disp_init θ
========================================================================
*/
void
x_player::erase_face(Window win)
{
	XCopyArea(dis,
			  waku,
			  win,
			  gc,
			  gx, gy,
			  FACE_X, FACE_Y,
			  gx, gy);
}


/*
========================================================================
ǽ: ̾ɽ
: win = Window
: ʤ
­: 
========================================================================
*/
void
x_player::disp_name(Window win)
{
	set_text_color(BlackPixel(dis, scr));
	set_text_mode(TEXT_TRANSPARENT);
	draw_string(win, tx*8, ty*16, name);
}


/*
========================================================================
ǽ: ̾ξõ
: win = Window
: ʤ
­: 
========================================================================
*/
void
x_player::erase_name(Window win)
{
	XCopyArea(dis,
			  waku,
			  win,
			  gc,
			  tx*8, ty*16,
			  strlen(name)*7, 16,
			  tx*8, ty*16);
}


/*
========================================================================
ǽ: 껥ɽ
: win = Window
: ʤ
­: ѤɽΤ
========================================================================
*/
void
x_player::disp_hand(Window win)
{
	unsigned long red, blue;
	int len;
	
	XCopyArea(dis,
			  waku,
			  win,
			  gc, 
			  tx*8, (ty+1)*16, 16*5, 16,
			  tx*8, (ty+1)*16);
	red = alloc_color(0xff, 0, 0);
	blue = alloc_color(0, 0, 0xff);
	set_text_mode(TEXT_TRANSPARENT);
	set_text_color(blue);
	len = draw_string(win, tx*8, (ty+1)*16, "Ĥ");
	set_text_color(red);
	if (num >= 10) {
		len += draw_string(win, tx*8 + len, (ty+1)*16, "");
	}
	switch ( num%10 ) {
	case 0: len += draw_string(win, tx*8 + len, (ty+1)*16, "" ); break;
	case 1: len += draw_string(win, tx*8 + len, (ty+1)*16, "" ); break;
	case 2: len += draw_string(win, tx*8 + len, (ty+1)*16, "" ); break;
	case 3: len += draw_string(win, tx*8 + len, (ty+1)*16, "" ); break;
	case 4: len += draw_string(win, tx*8 + len, (ty+1)*16, "" ); break;
	case 5: len += draw_string(win, tx*8 + len, (ty+1)*16, "" ); break;
	case 6: len += draw_string(win, tx*8 + len, (ty+1)*16, "" ); break;
	case 7: len += draw_string(win, tx*8 + len, (ty+1)*16, "" ); break;
	case 8: len += draw_string(win, tx*8 + len, (ty+1)*16, "" ); break;
	case 9: len += draw_string(win, tx*8 + len, (ty+1)*16, "" ); break;
	}
	set_text_color(blue);
	draw_string(win, tx*8 + len, (ty+1)*16, "");
}


/*
========================================================================
ǽ: ѥɽ
: win = Window
: ʤ
­: 
========================================================================
*/
void
x_player::disp_pass(Window win)
{
	unsigned long red;
	
	XCopyArea(dis,
			  waku,
			  win,
			  gc, 
			  (tx+6)*8, ty*16, 8*4, 16,
			  (tx+6)*8, ty*16);
	red = alloc_color(0xff, 0, 0);
	set_text_mode(TEXT_TRANSPARENT);
	set_text_color(red);
	draw_string(win, (tx+6)*8, ty*16, "Ѥ");
}


/*
========================================================================
ǽ: ѥξõ
: win = Window
: ʤ
­: 
========================================================================
*/
void
x_player::erase_pass(Window win)
{
	XCopyArea(dis,
			  waku,
			  win,
			  gc, 
			  (tx+6)*8, ty*16, 8*4, 16,
			  (tx+6)*8, ty*16);
}


/*
========================================================================
ǽ: ɽ
: win = Window
: ʤ
­: 
========================================================================
*/
void
x_player::disp_rank(Window win, int mode)
{
	unsigned long red, blue;
	
	XCopyArea(dis,
			  waku,
			  win,
			  gc, 
			  tx*8, ty*16, 8*6, 16,
			  tx*8, ty*16);
	if (rank!=-1) {
		red = alloc_color(0xff, 0, 0);
		blue = alloc_color(0, 0, 0xff);
		set_text_mode(TEXT_TRANSPARENT);
		if (mode==0) {
			set_text_color(blue);
		} else {
			set_text_color(red);
		}
		draw_string(win, tx*8, ty*16, rk[rank]);
	}
}


/*
========================================================================
ǽ: ξõ
: win = Window
: ʤ
­: 
========================================================================
*/
void
x_player::erase_rank(Window win)
{
	XCopyArea(dis,
			  waku,
			  win,
			  gc, 
			  tx*8, ty*16, 8*6, 16,
			  tx*8, ty*16);
}



